#ifndef __AT45DB321D_H__
#define __AT45DB321D_H__
#include <board.h>

/* AT45DB321D Commands */
#define DF_TRANSFER_PAGE_TO_BUFFER_1   0x53
#define DF_TRANSFER_PAGE_TO_BUFFER_2   0x55
#define DF_STATUS_REGISTER_READ 0xD7
#define DF_READ_MANUFACTURER_AND_DEVICE_ID   0x9F
#define DF_PAGE_READ		0xD2
#define DF_PAGE_WRITE		0x82
#define DF_BUFFER_1_READ	0xD4
#define DF_BUFFER_2_READ	0xD6
#define DF_BUFFER_1_WRITE	0x84
#define DF_BUFFER_2_WRITE	0x87
#define DF_BUFFER_1_TO_PAGE_WITH_ERASE   0x83
#define DF_BUFFER_2_TO_PAGE_WITH_ERASE   0x86
#define DF_PAGE_ERASE   0x81
#define DF_BLOCK_ERASE  0x50
#define DF_SECTOR_ERASE 0x7C
#define DF_CHIP_ERASE_0 0xC7
#define DF_CHIP_ERASE_1 0x94
#define DF_CHIP_ERASE_2 0x80
#define DF_CHIP_ERASE_3 0x9A
#define CONTINUOUS_ARRAY_READ 0x03
#define POWERDOWN       0xB9
#define POWERRESUME     0xAB
#define PGSIZE          528
#define FCS             GPIO0_2
#define FRST            GPIO3_1
#define NPAGES          8192


void flashmem_init(void);
void PageRead(uint32_t PageAdr, uint16_t ByteAdr, uint8_t *buf);
void PageWrite(uint32_t PageAdr, uint16_t ByteAdr, uint8_t *buf);
void BufferRead(uint8_t Bufno, uint16_t ByteAdr, uint8_t *buf);
void BufferWrite(uint8_t Bufno, uint16_t ByteAdr, uint8_t *buf);
void BufferToPage(uint8_t BufferNum, uint32_t PageAdr);
void PageToBuffer(uint8_t BufferNum, uint32_t PageAdr);
void PageErase(uint32_t PageAdr);
void ChipErase(void);
void ReadManufacturerID(uint8_t *buf);
uint8_t ReadStatusReg(void);
uint8_t ReadStatus(void);
void WaitReady(void);
void powerdown(void);
void powerresume(void);
uint8_t ByteRead(uint32_t PageAdr, uint16_t ByteAdr);

#endif
